#ifndef __INC_POS_PLIB_SPDOS_H
#define __INC_POS_PLIB_SPDOS_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>SpDOS.h<<   08 Mar 1997    08:49:27 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PEXEC_LIBRARY_H
#include "p:pExec/Library.h"
#endif

extern struct pOS_DosBase *gb_DosBase;
/*extern struct pOS_DosLibFunction *gb_DosLib; */

struct pOS_DosNotifyReq;
struct pOS_Task;
struct pOS_IOStruct;

/*----------------------------------
-----------------------------------*/
struct pOS_DosLibFunction
{

  BOOL (*pOS_GetSegmentPtrInfo_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_SegmentLst*,_R_A1 const pOS_Segment*,_R_A2 const VOID*,_R_A3 pOS_SegmentInfo*);
  UBYTE _d195[8];
  BOOL (*pOS_SetProgramName_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*);
  UBYTE _d194[8];
  BOOL (*pOS_GetProgramName_func)(_R_LB pOS_DosBase*,_R_A0 CHAR*,_R_D0 size_t);
  UBYTE _d193[8];
  __ARID__ const pOS_ExList* (*pOS_LockShellPathList_func)(_R_LB pOS_DosBase*);
  UBYTE _d192[8];
  VOID (*pOS_UnlockShellPathList_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ const pOS_ExList*);
  UBYTE _d191[8];
  BOOL (*pOS_GetDosInfoDataFH_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileHandle*,_R_A1 pOS_DosInfoData*);
  UBYTE _d190[8];

/** 190 **/
  VOID (*pOS_LockDosProcess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Process*);
  UBYTE _d189[8];
  VOID (*pOS_UnlockDosProcess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Process*);
  UBYTE _d188[8];
  pOS_IOStruct* (*pOS_OpenFHIOStruct_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d187[8];
  VOID (*pOS_CloseFHIOStruct_func)(_R_LB pOS_DosBase*,_R_A0 pOS_IOStruct*);
  UBYTE _d186[8];
  pOS_IOStruct* (*pOS_OpenIOStruct_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_D0 ULONG);
  UBYTE _d185[8];
  VOID (*pOS_CloseIOStruct_func)(_R_LB pOS_DosBase*,_R_A0 pOS_IOStruct*);
  UBYTE _d184[8];
  pOS_FileHandle* (*pOS_SetStdInput_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d183[8];
  pOS_FileHandle* (*pOS_SetStdOutput_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d182[8];
  pOS_FileHandle* (*pOS_SetStdErrOutput_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d181[8];
  ULONG (*pOS_DosString_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 CHAR*,_R_D0 size_t,_R_D1 ULONG,_R_D2 ULONG);
  UBYTE _d180[8];

/** 180 **/
  BOOL (*pOS_WriteDosArgsA_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 ULONG* area,_R_D0 size_t,
                       _R_A2 const pOS_DosArgs*,_R_A3 const pOS_TagItem*);
  UBYTE _d179[8];
  SLONG (*pOS_IsInfinite_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,
                               _R_A2 const pOS_FileLock*,_R_A3 const dosname_t*);
  UBYTE _d178[8];
  BOOL (*pOS_CloneProcessPath_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_Process*,_R_A1 pOS_Process*);
  UBYTE _d177[8];
  VOID (*pOS_DeleteProcess_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_Process*,_R_A1 pOS_Task*,_R_D0 ULONG);
  UBYTE _d176[8];
  ULONG (*pOS_SetShellFail_func)(_R_LB pOS_DosBase*,_R_D0 ULONG);
  UBYTE _d175[8];
  pOS_FileLock* (*pOS_CreatePath_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*);
  UBYTE _d174[8];
  BOOL (*pOS_RenameObjectName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 const dosname_t*);
  UBYTE _d173[8];
  BOOL (*pOS_SetObjectDateName_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 const pOS_DateStamp*);
  UBYTE _d172[8];
  BOOL (*pOS_SetObjectSizeName_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const dosname_t*,_R_D0 dossize_t);
  UBYTE _d171[8];
  BOOL (*pOS_GetDosInfoDataName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 pOS_DosInfoData*);
  UBYTE _d170[8];

/** 170 **/
  BOOL (*pOS_SetObjectCommentName_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 const CHAR*);
  UBYTE _d169[8];
  BOOL (*pOS_SetObjectProtectionName_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const dosname_t*,_R_D0 ULONG);
  UBYTE _d168[8];
  BOOL (*pOS_ExamineObjectName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 pOS_FileInfoBlock*);
  UBYTE _d167[8];
  BOOL (*pOS_CopyObjectName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 const dosname_t*,_R_D0 ULONG);
  UBYTE _d166[8];
  BOOL (*pOS_MoveObjectName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,_R_A2 const dosname_t*,_R_D0 ULONG);
  UBYTE _d165[8];
  VOID (*pOS_LockDosDevList_func)(_R_LB pOS_DosBase*);
  UBYTE _d164[8];
  VOID (*pOS_UnlockDosDevList_func)(_R_LB pOS_DosBase*);
  UBYTE _d163[8];
  pOS_FileLock* (*pOS_GetBootLock_func)(_R_LB pOS_DosBase*);
  UBYTE _d162[8];
  VOID (*pOS_DestructProcess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Process*);
  UBYTE _d161[8];
  VOID (*pOS_ConstructDosLk_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 pOS_DosDevice*,_R_D0 ULONG mode);
  UBYTE _d160[8];

/** 160 **/
  VOID (*pOS_DestructDosLk_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*);
  UBYTE _d159[8];
  VOID (*pOS_ConstructDosFH_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 pOS_DosDevice*,_R_D0 ULONG mode);
  UBYTE _d158[8];
  VOID (*pOS_DestructDosFH_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d157[8];
  UWORD (*pOS_MountDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 const dosname_t*,_R_A2 const CHAR*);
  UBYTE _d156[8];
  pOS_DosDevice* (*pOS_GetDosDeviceName_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_D0 ULONG);
  UBYTE _d155[8];
  pOS_DosMountDevice* (*pOS_GetDosMountName_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*);
  UBYTE _d154[8];
  pOS_DosDevice* (*pOS_CreateDosDevFromMount_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_DosMountDevice*);
  UBYTE _d153[8];
  BOOL (*pOS_DeleteDosAssign_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 const pOS_FileLock*,_R_D0 ULONG);
  UBYTE _d152[8];
  BOOL (*pOS_AddDosAssign_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 __ARID__ pOS_FileLock*,_R_D0 ULONG);
  UBYTE _d151[8];
  BOOL (*pOS_GetNextDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevPathInfo*);
  UBYTE _d150[8];

/** 150 **/
  pOS_DosMountDevice* (*pOS_CreateDosMount_func)(_R_LB pOS_DosBase*,_R_D0 ULONG);
  UBYTE _d149[8];
  VOID (*pOS_DeleteDosMount_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosMountDevice*);
  UBYTE _d148[8];
  BOOL (*pOS_ChangeDosFileAccess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_D0 ULONG);
  UBYTE _d147[8];
  BOOL (*pOS_SetFileDate_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const pOS_DateStamp*);
  UBYTE _d146[8];
  BOOL (*pOS_SetFileSize_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 dossize_t);
  UBYTE _d145[8];
  __ARID__ pOS_FileHandle* (*pOS_OpenFileFromLock_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*);
  UBYTE _d144[8];
  BOOL (*pOS_NameFromFH_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileHandle*,_R_A1 dosname_t*,_R_D0 size_t);
  UBYTE _d143[8];
  BOOL (*pOS_SetDosScreenMode_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 ULONG);
  UBYTE _d142[8];
  BOOL  (*pOS_SameDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const pOS_FileLock*);
  UBYTE _d141[8];
  ULONG (*pOS_SameDosObject_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const pOS_FileLock*);
  UBYTE _d140[8];

/** 140 **/
  BOOL (*pOS_ChangeDosObjectAccess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_D0 ULONG);
  UBYTE _d139[8];
  pOS_FileLock* (*pOS_GetProgDir_func)(_R_LB pOS_DosBase*);
  UBYTE _d138[8];
  pOS_DosDevice* (*pOS_GetDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*);
  UBYTE _d137[8];
  pOS_DosDevice* (*pOS_GetDosHandler_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*);
  UBYTE _d136[8];
  dossize_t (*pOS_AddDosDeviceBuffers_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*,_R_D0 SLONG);
  UBYTE _d135[8];
  BOOL (*pOS_InhibitDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*,_R_D0 ULONG);
  UBYTE _d134[8];
  BOOL (*pOS_RelabelDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*,_R_A1 const CHAR*);
  UBYTE _d133[8];
  const pOS_DosToken* (*pOS_DosFindToken_func)(_R_LB pOS_DosArgs*,_R_A0 const CHAR*);
  UBYTE _d132[8];
  BOOL (*pOS_GetCurrentDirName_func)(_R_LB pOS_DosBase*,_R_A0 dosname_t*,_R_D0 size_t);
  UBYTE _d131[8];
  VOID (*pOS_ConstructDosMsgNotify_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosNotifyReq*,
                                 _R_A1 const dosname_t*,_R_D0 ULONG,_R_A2 pOS_MsgPort*);
  UBYTE _d130[8];
  VOID (*pOS_ConstructDosSigNotify_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosNotifyReq*,
                                 _R_A1 const dosname_t*,_R_D0 ULONG,_R_A2 pOS_Task*,_R_D1 ULONG);

/** 130 **/
  UBYTE _d129[8];
  VOID (*pOS_DestructDosNotify_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosNotifyReq*);
  UBYTE _d128[8];
  BOOL (*pOS_DosStartNotify_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosNotifyReq*);
  UBYTE _d127[8];
  VOID (*pOS_DosEndNotify_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosNotifyReq*);
  UBYTE _d126[8];
  BOOL (*pOS_DosErrorReportA_func)(_R_LB pOS_DosBase*,_R_D0 ULONG errCode,_R_A0 const pOS_TagItem*);
  UBYTE _d125[8];
  BOOL (*pOS_SetPrompt_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*);
  UBYTE _d124[8];
  BOOL (*pOS_GetPrompt_func)(_R_LB pOS_DosBase*,_R_A0 CHAR*,_R_D0 size_t);
  UBYTE _d123[8];
/*--- */
  ULONG (*pOS_FileUnGetC_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_D0 ULONG);
  UBYTE _d122[8];
  BOOL  (*pOS_ExamineFH_func)(_R_LB pOS_DosBase* dos,_R_A0 const pOS_FileHandle* fh,_R_A1 pOS_FileInfoBlock* fib);
  UBYTE _d121[8];
  ULONG (*pOS_FileFRead_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 APTR,_R_D0 size_t,_R_D1 ULONG);
  UBYTE _d120[8];

/** 120 **/
  ULONG (*pOS_FileFWrite_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const APTR,_R_D0 size_t,_R_D1 ULONG);
  UBYTE _d119[8];
  ULONG (*pOS_FileEOF_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d118[8];
  ULONG (*pOS_FilePutC_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_D0 ULONG);
  UBYTE _d117[8];
  ULONG (*pOS_FilePuts_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const UBYTE*);
  UBYTE _d116[8];
  BOOL (*pOS_InternalLoadSegment_func)(_R_LB pOS_DosBase*,_R_A0 pOS_ISegmentData*);
  UBYTE _d115[8];
  BOOL (*pOS_InternalUnloadSegment_func)(_R_LB pOS_DosBase*,_R_A0 pOS_ISegmentData*);
  UBYTE _d114[8];
  __ARID__ APTR (*pOS_AllocDosObject_func)(_R_LB pOS_DosBase*,_R_D0 ULONG type,_R_D1 ULONG);
  UBYTE _d113[8];
  VOID (*pOS_FreeDosObject_func)(_R_LB pOS_DosBase*,_R_D0 ULONG type,_R_A0 __ARID__ APTR);
  UBYTE _d112[8];
  ULONG (*pOS_AllocDosProcessNum_func)(_R_LB pOS_DosBase*,_R_D0 ULONG num);
  UBYTE _d111[8];
  VOID (*pOS_FreeDosProcessNum_func)(_R_LB pOS_DosBase*,_R_D0 ULONG num);
  UBYTE _d110[8];

/** 110 **/
  VOID (*pOS_LockProcessList_func)(_R_LB pOS_DosBase*);
  UBYTE _d109[8];
  VOID (*pOS_UnlockProcessList_func)(_R_LB pOS_DosBase*);
  UBYTE _d108[8];
  __ARID__ pOS_FileHandle* (*pOS_OpenFile_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,
                               _R_A1 const dosname_t*,_R_D0 ULONG);
  UBYTE _d107[8];
  VOID (*pOS_CloseFile_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_FileHandle*);
  UBYTE _d106[8];
  dossize_t (*pOS_ReadFile_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 APTR,_R_D0 dossize_t);
  UBYTE _d105[8];
  dossize_t (*pOS_WriteFile_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const APTR,_R_D0 dossize_t);
  UBYTE _d104[8];
  dossize_t (*pOS_SeekFile_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_D0 dospos_t,_R_D1 SLONG mode);
  UBYTE _d103[8];
  dossize_t (*pOS_VFWritef_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const CHAR* format,_R_A2 const ULONG* argv);
  UBYTE _d102[8];
  __ARID__ pOS_FileHandle* (*pOS_DupFileHandle_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileHandle*);
  UBYTE _d101[8];
  BOOL (*pOS_IsFileInteractive_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d100[8];

/** 100 **/
  dossize_t (*pOS_WaitForChar_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 const pOS_TimeVal*);
  UBYTE _d99[8];
  BOOL (*pOS_SetFileHandleBuf_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 UBYTE*,_R_D0 ULONG,_R_D1 dossize_t);
  UBYTE _d98[8];
  BOOL (*pOS_FileFlush_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d97[8];
  ULONG (*pOS_FileGetC_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*);
  UBYTE _d96[8];
  UBYTE* (*pOS_FileGets_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileHandle*,_R_A1 UBYTE*,_R_D0 size_t);
  UBYTE _d95[8];
  __ARID__ pOS_FileLock* (*pOS_LockObject_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,
                           _R_A1 const dosname_t*,_R_D0 ULONG mode);
  UBYTE _d94[8];
  VOID (*pOS_UnlockObject_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_FileLock*);
  UBYTE _d93[8];
  __ARID__ pOS_FileLock* (*pOS_DupObjectLock_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*);
  UBYTE _d92[8];
  pOS_FileLock* (*pOS_ParentObjectDir_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*);
  UBYTE _d91[8];
  BOOL (*pOS_NameFromObjectLock_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 dosname_t*,_R_D0 size_t);
  UBYTE _d90[8];

/** 90 **/
  BOOL (*pOS_ExamineObject_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 pOS_FileInfoBlock*);
  UBYTE _d89[8];
  BOOL (*pOS_ExNextObject_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 pOS_FileInfoBlock*);
  UBYTE _d88[8];
  BOOL (*pOS_IsFileSystem_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*);
  UBYTE _d87[8];
  __ARID__ pOS_FileLock* (*pOS_CreateDirectory_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,
                                    _R_A1 const dosname_t*);
  UBYTE _d86[8];
  BOOL (*pOS_RenameObject_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 pOS_FileLock*,_R_A2 const dosname_t*);
  UBYTE _d85[8];
  BOOL (*pOS_DeleteObjectLk_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_FileLock*);
  UBYTE _d84[8];
  BOOL (*pOS_IsFileSystemName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock* currDir,_R_A1 const dosname_t* name);
  UBYTE _d83[8];
  BOOL (*pOS_DeleteObjectName_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock* currDir,_R_A1 const dosname_t* name);
  UBYTE _d82[8];
  BOOL (*pOS_SetObjectDate_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const pOS_DateStamp*);
  UBYTE _d81[8];
  BOOL (*pOS_SetObjectSize_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_D0 dossize_t size);
  UBYTE _d80[8];

/** 80 **/
  BOOL (*pOS_GetDosInfoData_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 pOS_DosInfoData*);
  UBYTE _d79[8];
  BOOL (*pOS_SetObjectComment_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_A1 const CHAR*);
  UBYTE _d78[8];
  BOOL (*pOS_SetObjectProtection_func)(_R_LB pOS_DosBase*,_R_A0 pOS_FileLock*,_R_D0 ULONG);
  UBYTE _d77[8];
  BOOL (*pOS_AddPart_func)(_R_LB pOS_DosBase*,_R_A0 dosname_t*,_R_A1 const dosname_t*,_R_D0 size_t);
  UBYTE _d76[8];
  dosname_t* (*pOS_PathPart_func)(_R_LB pOS_DosBase*,_R_A0 const dosname_t*);
  UBYTE _d75[8];
  dosname_t* (*pOS_FilePart_func)(_R_LB pOS_DosBase*,_R_A0 const dosname_t*);
  UBYTE _d74[8];
  size_t (*pOS_SplitName_func)(_R_LB pOS_DosBase*,_R_A0 const dosname_t*,_R_D0 ULONG,
                       _R_A1 dosname_t*,_R_D1 size_t,_R_D2 size_t size);
  UBYTE _d73[8];
  __ARID__  pOS_MsgPort* (*pOS_CreateProc_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_D0 SLONG pri,
                              _R_A2 pOS_SegmentLst*,_R_D1 size_t stackSize);
  UBYTE _d72[8];
  SLONG (*pOS_SetIoErr_func)(_R_LB pOS_DosBase*,_R_D0 SLONG);
  UBYTE _d71[8];
  SLONG (*pOS_GetIoErr_func)(_R_LB pOS_DosBase*);
  UBYTE _d70[8];

/** 70 **/
  VOID (*pOS_ExitProcess_func)(_R_LB pOS_DosBase*,_R_D0 ULONG);
  UBYTE _d69[8];
  pOS_FileHandle* (*pOS_GetStdInput_func)(_R_LB pOS_DosBase*);
  UBYTE _d68[8];
  pOS_FileHandle* (*pOS_GetStdOutput_func)(_R_LB pOS_DosBase*);
  UBYTE _d67[8];
  pOS_FileHandle* (*pOS_GetStdErrOutput_func)(_R_LB pOS_DosBase*);
  UBYTE _d66[8];
  __ARID__ pOS_FileHandle* (*pOS_SetConsoleFH_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_FileHandle*);
  UBYTE _d65[8];
  __ARID__ pOS_FileLock* (*pOS_SetProgDir_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_FileLock*);
  UBYTE _d64[8];
  VOID (*pOS_ConstructProcess_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Process*);
  UBYTE _d63[8];
  VOID (*pOS_DosDelay_func)(_R_LB pOS_DosBase*,_R_D0 ULONG ticks);
  UBYTE _d62[8];
  pOS_Process* (*pOS_CreateProcessA_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_TagItem*);
  UBYTE _d61[8];
  SLONG (*pOS_RunCommand_func)(_R_LB pOS_DosBase*,_R_A0 pOS_SegmentLst*,_R_D0 size_t stackSize,
                       _R_A1 pOS_FileHandle* cin,_R_A2 pOS_FileHandle* cout,
                       _R_A3 pOS_FileHandle* cerr,_R_A4 const CHAR* line);
  UBYTE _d60[8];

/** 60 **/
  SLONG (*pOS_SystemA_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 const pOS_TagItem*);
  UBYTE _d59[8];
  BOOL (*pOS_AddSegment_func)(_R_LB pOS_DosBase*,_R_A0 pOS_SegmentLst*);
  UBYTE _d58[8];
  BOOL (*pOS_RemSegment_func)(_R_LB pOS_DosBase*,_R_A0 pOS_SegmentLst*);
  UBYTE _d57[8];
  __ARID__ pOS_SegmentLst* (*pOS_OpenSegment_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_D0 ULONG mode);
  UBYTE _d56[8];
  VOID (*pOS_CloseSegment_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_SegmentLst*);
  UBYTE _d55[8];
  __ARID__ pOS_SegmentLst* (*pOS_LoadSegmentA_func)(_R_LB pOS_DosBase*,_R_A0 const dosname_t*,_R_A1 const pOS_TagItem*);
  UBYTE _d54[8];
  VOID (*pOS_UnloadSegment_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_SegmentLst*);
  UBYTE _d53[8];
  pOS_Process* (*pOS_InitDosIOReq_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_DosDevice*,_R_A1 pOS_DosIOReq*);
  UBYTE _d52[8];
  VOID (*pOS_InitDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*);
  UBYTE _d51[8];
  VOID (*pOS_AddDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*);
  UBYTE _d50[8];

/** 50 **/
  VOID (*pOS_RemDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*);
  UBYTE _d49[8];
  BOOL (*pOS_OpenDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevPathInfo*);
  UBYTE _d48[8];
  VOID (*pOS_CloseDosDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevPathInfo*);
  UBYTE _d47[8];
  VOID (*pOS_AddDosDefDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDefDevice*);
  UBYTE _d46[8];
  VOID (*pOS_RemDosDefDevice_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDefDevice*);
  UBYTE _d45[8];
  pOS_DosDevice* (*pOS_CreateDosAssign_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR* assignName,
                                     _R_A1 __ARID__ pOS_FileLock*,_R_A2 const dosname_t*,_R_D0 ULONG);
  UBYTE _d44[8];
  pOS_DosDevice* (*pOS_CreateDOSTemplate_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*);
  UBYTE _d43[8];
  pOS_DosDevice* (*pOS_CreateDOSVolumeA_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*,
                         _R_A1 const CHAR*,_R_A2 const pOS_DateStamp*,_R_A3 const pOS_TagItem*);
  UBYTE _d42[8];
  pOS_DosDevice* (*pOS_OpenDOSVolumeA_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*,
                         _R_A1 const CHAR*,_R_A2 const pOS_DateStamp*,_R_A3 const pOS_TagItem*);
  UBYTE _d41[8];
  VOID (*pOS_CloseDOSVolume_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosDevice*);
  UBYTE _d40[8];

/** 40 **/
  VOID (*pOS_DeleteDosArgs_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_DosArgs*);
  UBYTE _d39[8];
  const CHAR* (*pOS_CreateDosTokenString_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosArgs*,_R_A1 const CHAR*);
  UBYTE _d38[8];
  pOS_DosErrors (*pOS_CreateDosTokenList_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosArgs*);
  UBYTE _d37[8];
  pOS_DosErrors (*pOS_InterpretDosTokenList_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosArgs*);
  UBYTE _d36[8];
  __ARID__ pOS_DosArgs* (*pOS_CreateDosArgs_func)(_R_LB pOS_DosBase*);
  UBYTE _d35[8];
  __ARID__ pOS_DosArgs* (*pOS_ReadDosArgsA_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,
                                         _R_A1 ULONG*,_R_D0 size_t areaNum,_R_A2 const pOS_TagItem*);
  UBYTE _d34[8];
  VOID (*pOS_PrintDosArgList_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DosArgs*);
  UBYTE _d33[8];
  __ARID__ pOS_Parse* (*pOS_CreateParse_func)(_R_LB pOS_DosBase*,_R_A0 pOS_ParseObject** stLow,_R_A1 pOS_ParseObject** stUpp);
  UBYTE _d32[8];
  VOID (*pOS_DeleteParse_func)(_R_LB pOS_DosBase*,_R_A0 __ARID__ pOS_Parse*);
  UBYTE _d31[8];
  VOID (*pOS_ConstructParse_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Parse*);
  UBYTE _d30[8];

/** 30 **/
  VOID (*pOS_DestructParse_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Parse*);
  UBYTE _d29[8];
  pOS_ParseObject* (*pOS_Parsing_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Parse*,_R_D0 ULONG priLevel);
  UBYTE _d28[8];
  VOID (*pOS_ConstructPattern_func)(_R_LB pOS_DosBase*,_R_A0 pOS_PatternMatching*);
  UBYTE _d27[8];
  VOID (*pOS_DestructPattern_func)(_R_LB pOS_DosBase*,_R_A0 pOS_PatternMatching*);
  UBYTE _d26[8];
  BOOL (*pOS_ParsePatternA_func)(_R_LB pOS_DosBase*,_R_A0 pOS_PatternMatching*,_R_A1 const CHAR*,_R_A2 const pOS_TagItem*);
  UBYTE _d25[8];
  BOOL (*pOS_MatchPattern_func)(_R_LB pOS_DosBase*,_R_A0 __CONST__ pOS_PatternObj* area[],_R_A1 const CHAR*);
  UBYTE _d24[8];
  pOS_DosErrors (*pOS_PathMatchFirst_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_FileLock*,_R_A1 const dosname_t*,
                                           _R_A2 pOS_AnchorPath* ap,_R_A3 const CHAR*,_R_D0 ULONG);
  UBYTE _d23[8];
  VOID (*pOS_PathMatchEnd_func)(_R_LB pOS_DosBase*,_R_A0 pOS_AnchorPath*);
  UBYTE _d22[8];
  pOS_DosErrors (*pOS_PathMatchNext_func)(_R_LB pOS_DosBase*,_R_A0 pOS_AnchorPath*);
  UBYTE _d21[8];
  ULONG (*pOS_DosCheckSignal_func)(_R_LB pOS_DosBase*,_R_D0 ULONG signalMask);
  UBYTE _d20[8];

/** 20 **/
  pOS_DateStamp* (*pOS_GetDateStamp_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DateStamp*);
  UBYTE _d19[8];
  SWORD (*pOS_CompareDates_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_DateStamp*,_R_A1 const pOS_DateStamp*);
  UBYTE _d18[8];
  BOOL (*pOS_DateToStr_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DateTime*);
  UBYTE _d17[8];
  BOOL (*pOS_StrToDate_func)(_R_LB pOS_DosBase*,_R_A0 pOS_DateTime*);
  UBYTE _d16[8];
  ULONG (*pOS_GetVar_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 UBYTE*,_R_D0 size_t,_R_D1 ULONG flags);
  UBYTE _d15[8];
  pOS_LocalVar* (*pOS_FindVar_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_D0 ULONG flags);
  UBYTE _d14[8];
  BOOL (*pOS_SetVar_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 const UBYTE*,_R_D0 size_t,_R_D1 ULONG flags);
  UBYTE _d13[8];
  BOOL (*pOS_DeleteVar_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_D0 ULONG flags);
  UBYTE _d12[8];
  BOOL (*pOS_SetVarLoc_func)(_R_LB pOS_DosBase*,_R_A0 pOS_LocalVar*,_R_A1 const UBYTE*,_R_D0 size_t);
  UBYTE _d11[8];
  BOOL (*pOS_CloneVars_func)(_R_LB pOS_DosBase*,_R_A0 const pOS_ExList*,_R_A1 pOS_ExList*,_R_A2 pOS_MemPool*,_R_D0 ULONG flags);
  UBYTE _d10[8];

/** 10 **/
  const CHAR* (*pOS_GetDosErrText_func)(_R_LB pOS_DosBase* dos,_R_D0 pOS_DosErrors err);
  UBYTE _d9[8];
  BOOL (*pOS_PrintDosErr_func)(_R_LB pOS_DosBase* dos,_R_A0 pOS_FileHandle*,_R_A1 const CHAR* str,_R_D0 ULONG error);
  UBYTE _d8[8];
  __ARID__ pOS_FileLock* (*pOS_SetCurrentDirLock_func)(_R_LB pOS_DosBase* dos,_R_A0 __ARID__ pOS_FileLock* lk);
  UBYTE _d7[8];
  BOOL (*pOS_SetCurrentDirName_func)(_R_LB pOS_DosBase* dos,_R_A0 const dosname_t* name);
  UBYTE _d6[8];
  VOID (*pOS_ConstructShell_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Shell*);
  UBYTE _d5[8];
  VOID (*pOS_DestructShell_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Shell*);
  UBYTE _d4[8];
  VOID (*pOS_ConstructShellScript_func)(_R_LB pOS_DosBase*,_R_A0 pOS_ShellScript*);
  UBYTE _d3[8];
  VOID (*pOS_DestructShellScript_func)(_R_LB pOS_DosBase*,_R_A0 pOS_Shell*,_R_A1 pOS_ShellScript*);
  UBYTE _d2[8];
  CHAR* (*pOS_DosGetAliasComm_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 CHAR* buf,_R_D0 size_t bufSize);
  UBYTE _d1[8];
  CHAR* (*pOS_DosGetResString1_func)(_R_LB pOS_DosBase*,_R_A0 const CHAR*,_R_A1 CHAR* buf,_R_D0 size_t bufSize,_R_A2 pOS_Shell*);
  UBYTE _d0[8];

  pOS_StdLibraryFunction StdLib;
}; /* => DosBase */


#endif
