#ifndef __INC_POS_PLIB_SPINTUI_H
#define __INC_POS_PLIB_SPINTUI_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>SpIntui.h<<   29 Jan 1997    15:56:05 - (C) ProDAD
*******************************************************************/
#include "p:pExec/Device.h"

extern struct pOS_IntuiDevice *gb_IntuiBase;

struct pOS_Callback;

/*----------------------------------
-----------------------------------*/
struct pOS_IntuiLibFunction
{

  pOS_MenuItem* (*pOS_GetMenuVKey_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_MenuList*,_R_D0 ULONG);
  UBYTE _d111[8];
  BOOL (*pOS_HandleMenuItemEvent_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuList*,_R_A1 pOS_MenuItem*);
  UBYTE _d110[8];

/** 110 **/
  VOID (*pOS_AddWindowTickHandler_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Callback*);
  UBYTE _d109[8];
  VOID (*pOS_RemWindowTickHandler_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Callback*);
  UBYTE _d108[8];
  BOOL (*pOS_GetVisibleIRect_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_Window*,_R_A1 pOS_Rectangle*,_R_A2 const pOS_Layer*);
  UBYTE _d107[8];
  BOOL (*pOS_SetScreenPosition_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*,_R_D0 SLONG,_R_D1 SLONG);
  UBYTE _d106[8];
  BOOL (*pOS_ScreenToFront_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*);
  UBYTE _d105[8];
  BOOL (*pOS_ScreenToBack_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*);
  UBYTE _d104[8];
  pOS_MenuList* (*pOS_SetMenuStrip_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_MenuList*);
  UBYTE _d103[8];
  ULONG (*pOS_SetMouseQueue_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG);
  UBYTE _d102[8];
  ULONG (*pOS_SetKeyQueue_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG);
  UBYTE _d101[8];
  ULONG (*pOS_SetUpdateGadQueue_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG);
  UBYTE _d100[8];

/** 100 **/
  pOS_GfxMap* (*pOS_SetWinBgFill_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_GfxMap*,_R_D0 SLONG,_R_D1 SLONG);
  UBYTE _d99[8];
  VOID (*pOS_CurrentTime_func)(_R_LB pOS_IntuiDevice*,_R_A0 ULONG*,_R_A1 ULONG*);
  UBYTE _d98[8];
  BOOL (*pOS_InactivateGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*);
  UBYTE _d97[8];
  BOOL (*pOS_IsGadgetActive_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_Gadget*);
  UBYTE _d96[8];
  VOID (*pOS_LockIntuiGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*);
  UBYTE _d95[8];
  VOID (*pOS_UnlockIntuiGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*);
  UBYTE _d94[8];
  pOS_Task* (*pOS_SetWindowTask_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Task*,_R_D0 SLONG,_R_D1 SLONG);
  UBYTE _d93[8];
  BOOL (*pOS_GetWindowBorder_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*,_R_A1 pOS_WBox*,_R_D0 ULONG,_R_D1 ULONG,_R_D2 ULONG);
  UBYTE _d92[8];
  pOS_ColorMap* (*pOS_GetIColorMap_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_Screen*,_R_A1 const pOS_Window*);
  UBYTE _d91[8];
  VOID  (*pOS_InactivateWindow_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d90[8];

/** 90 **/
  ULONG (*pOS_SetWindowBusy_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG);
  UBYTE _d89[8];
  VOID (*pOS_AddDrag_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiUnit*,_R_A1 pOS_Drag*);
  UBYTE _d88[8];
  VOID (*pOS_RemDrag_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiUnit*,_R_A1 pOS_Drag*);
  UBYTE _d87[8];
  __ARID__ pOS_Drag* (*pOS_CreateDragA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_TagItem*);
  UBYTE _d86[8];
  VOID (*pOS_DeleteDrag_func)(_R_LB pOS_IntuiDevice*,_R_A0 __ARID__ pOS_Drag*);
  UBYTE _d85[8];
  BOOL (*pOS_CreateDragGfx_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_RastPort*,_R_A1 pOS_Drag*);
  UBYTE _d84[8];
  VOID (*pOS_DeleteDragGfx_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Drag*);
  UBYTE _d83[8];
  VOID (*pOS_ConstructDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*);
  UBYTE _d82[8];
  VOID (*pOS_DestructDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*);
  UBYTE _d81[8];
  BOOL (*pOS_LayoutDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*,_R_A1 pOS_RastPort*);
  UBYTE _d80[8];

/** 80 **/
  BOOL (*pOS_CreateDragListGfx_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*,_R_A1 pOS_RastPort*);
  UBYTE _d79[8];
  VOID (*pOS_DeleteDragListGfx_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*);
  UBYTE _d78[8];
  VOID (*pOS_RenderDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*,_R_D0 ULONG);
  UBYTE _d77[8];
  VOID (*pOS_MoveDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*,_R_D0 SLONG,_R_D1 SLONG,_R_D2 ULONG);
  UBYTE _d76[8];
  VOID (*pOS_RestoreDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*);
  UBYTE _d75[8];
  VOID (*pOS_SaveDragList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_DragList*);
  UBYTE _d74[8];
  const pOS_DropAttribute* (*pOS_GetDropAttFromDragList_func)(_R_LB pOS_IntuiDevice*,
              _R_A0 pOS_DragList*,_R_A1 const pOS_GadgetDrop*,_R_A2 const pOS_DropAttribute*);
  UBYTE _d73[8];
  pOS_IntuiMessage* (*pOS_CreateIMessage_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MsgPort*,_R_D0 size_t);
  UBYTE _d72[8];
  VOID (*pOS_DeleteIMessage_func)(_R_LB pOS_IntuiDevice*,_R_A0 __ARID__ pOS_IntuiMessage*);
  UBYTE _d71[8];
  VOID (*pOS_DisplayBeep_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*,_R_D0 ULONG);
  UBYTE _d70[8];

/** 70 **/
  BOOL  (*pOS_SetWindowMenuChecker_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_Window*,_R_A1 const pOS_MenuNum*,_R_D0 BOOL);
  UBYTE _d69[8];
  SLONG (*pOS_GetWindowMenuChecker_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_Window*,_R_A1 const pOS_MenuNum*);
  UBYTE _d68[8];
  BOOL  (*pOS_EnableWindowMenu_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_Window*,_R_A1 const pOS_MenuNum*,_R_D0 BOOL);
  UBYTE _d67[8];
  pOS_BubbleHelp* (*pOS_CreateBubbleHelpA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_TagItem*);
  UBYTE _d66[8];
  VOID (*pOS_DeleteBubbleHelp_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_BubbleHelp*);
  UBYTE _d65[8];
  pOS_Window* (*pOS_CreateRequestWinA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_TagItem*);
  UBYTE _d64[8];
  VOID (*pOS_DeleteRequestWin_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d63[8];
  SLONG (*pOS_EasyRequestArgs_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                          _R_A1 const pOS_EasyStruct*,_R_A2 ULONG*,_R_A3 const ULONG*);
  UBYTE _d62[8];
  SLONG (*pOS_RequestWinHandler_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 ULONG*,_R_D0 BOOL);
  UBYTE _d61[8];
  VOID (*pOS_RefreshGadgetsMd_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                             _R_A1 const pOS_Gadget*,_R_D0 ULONG,_R_D1 ULONG);
  UBYTE _d60[8];

/** 60 **/
  VOID (*pOS_LayoutGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_IBox*,_R_D0 ULONG);
  UBYTE _d59[8];
  VOID (*pOS_GetWindowIBox_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_IBox*,_R_A2 const pOS_Layer*);
  UBYTE _d58[8];
  BOOL (*pOS_CheckVisibleIBox_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_IBox*,_R_A2 const pOS_Layer*);
  UBYTE _d57[8];
  BOOL (*pOS_CheckVisibleIRect_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_Rectangle*,_R_A2 const pOS_Layer*);
  UBYTE _d56[8];
  BOOL (*pOS_SetWindowLimits_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG,_R_D1 ULONG,_R_D2 ULONG,_R_D3 ULONG);
  UBYTE _d55[8];
  VOID (*pOS_SetWindowTitles_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const CHAR*,_R_A2 const CHAR*);
  UBYTE _d54[8];
  BOOL (*pOS_CmpDoubleClick_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_DoubleClick* just,_R_A1 const pOS_DoubleClick*);
  UBYTE _d53[8];
  BOOL (*pOS_CheckDoubleClick_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_IntuiMessage*);
  UBYTE _d52[8];
  VOID (*pOS_LockIntuiGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d51[8];
  VOID (*pOS_UnlockIntuiGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d50[8];

/** 50 **/
  BOOL (*pOS_SysIMessage_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiMessage*);
  UBYTE _d49[8];
  pOS_Process* (*pOS_InitIntuiIOReq_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiStdReq*);
  UBYTE _d48[8];
  VOID (*pOS_LockIntuiBase_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiUnit*);
  UBYTE _d47[8];
  VOID (*pOS_UnlockIntuiBase_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiUnit*);
  UBYTE _d46[8];
  VOID (*pOS_SendInputEvent_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_InputEvent*);
  UBYTE _d45[8];
  __ARID__ pOS_Screen* (*pOS_OpenScreenA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_TagItem*);
  UBYTE _d44[8];
  BOOL (*pOS_CloseScreen_func)(_R_LB pOS_IntuiDevice*,_R_A0 __ARID__ pOS_Screen*);
  UBYTE _d43[8];
  pOS_Screen* (*pOS_LockPubScreen_func)(_R_LB pOS_IntuiDevice*,_R_A0 const CHAR*);
  UBYTE _d42[8];
  BOOL (*pOS_UnlockPubScreen_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*);
  UBYTE _d41[8];
  ULONG (*pOS_PubScreenStatus_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Screen*,_R_D0 ULONG);
  UBYTE _d40[8];

/** 40 **/
  __ARID__ pOS_Window* (*pOS_OpenWindowA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_TagItem*);
  UBYTE _d39[8];
  BOOL (*pOS_CloseWindow_func)(_R_LB pOS_IntuiDevice*,_R_A0 __ARID__ pOS_Window*);
  UBYTE _d38[8];
  BOOL (*pOS_ChangeWindowBox_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                      _R_D0 SLONG x,_R_D1 SLONG y,_R_D2 SLONG width,_R_D3 SLONG height);
  UBYTE _d37[8];
  BOOL (*pOS_ModifyIDCMP_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG idcmp);
  UBYTE _d36[8];
  BOOL (*pOS_ModifySharedIDCMP_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                       _R_D0 ULONG idcmp,_R_D1 ULONG mask);
  UBYTE _d35[8];
  BOOL (*pOS_WindowToFront_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d34[8];
  BOOL (*pOS_WindowToBack_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d33[8];
  BOOL (*pOS_BeginRefresh_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_List*);
  UBYTE _d32[8];
  BOOL (*pOS_EndRefresh_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_D0 ULONG);
  UBYTE _d31[8];
  VOID (*pOS_RefreshWindowFrame_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d30[8];

/** 30 **/
  VOID (*pOS_InvalidWindowRect_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                       _R_A1 const pOS_Rectangle*,_R_D0 ULONG mode);
  UBYTE _d29[8];
  VOID (*pOS_ActivateWindow_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d28[8];
  BOOL (*pOS_ZipWindow_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*);
  UBYTE _d27[8];
  VOID (*pOS_SetWindowMenu_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_ExList*,_R_A2 pOS_ExList* old);
  UBYTE _d26[8];
  VOID  (*pOS_AddGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_List*);
  UBYTE _d25[8];
  VOID  (*pOS_RemGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                       _R_A1 const pOS_Gadget*,_R_A2 pOS_List*,_R_D0 ULONG,_R_D1 ULONG);
  UBYTE _d24[8];
  VOID  (*pOS_AddGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*);
  UBYTE _d23[8];
  VOID  (*pOS_RemGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*);
  UBYTE _d22[8];
  VOID  (*pOS_RefreshGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,
                        _R_A1 const pOS_Gadget*,_R_D0 ULONG anz);
  UBYTE _d21[8];
  VOID  (*pOS_RefreshLayerGadgets_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 const pOS_Layer*);
  UBYTE _d20[8];

/** 20 **/
  __ARID__ APTR (*pOS_NewIObjectA_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_NClass*,_R_A1 const CHAR*,
                        _R_D0 ULONG ver,_R_A2 const pOS_TagItem*);
  UBYTE _d19[8];
  VOID  (*pOS_DisposeIObject_func)(_R_LB pOS_IntuiDevice*,_R_A0 __ARID__ APTR);
  UBYTE _d18[8];
  ULONG (*pOS_SetGadgetAttrsA_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*,
                           _R_A2 const pOS_TagItem*);
  UBYTE _d17[8];
  BOOL  (*pOS_GetGadgetAttr_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*,_R_D0 ULONG id,_R_A2 ULONG*);
  UBYTE _d16[8];
  BOOL  (*pOS_ActivateGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*);
  UBYTE _d15[8];
  VOID  (*pOS_EnableGadget_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_Window*,_R_A1 pOS_Gadget*,_R_D0 ULONG enable);
  UBYTE _d14[8];
  VOID (*pOS_DrawIObj_func)(_R_LB pOS_IntuiDevice*,_R_D0 SLONG x,_R_D1 SLONG y,
                    _R_A0 const pOS_IntuiObj*,_R_A1 pOS_RastPort*,_R_A2 const pOS_DrawInfo*,
                    _R_D2 ULONG mode,_R_A3 const pOS_Rectangle*);
  UBYTE _d13[8];
  VOID (*pOS_IObjDisposeList_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_IntuiObj*);
  UBYTE _d12[8];
  VOID (*pOS_IObjGetBoxList_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_IntuiObj*,
                    _R_A1 pOS_IObjectMethod*,_R_A2 pOS_Rectangle*);
  UBYTE _d11[8];
  VOID (*pOS_IObjDrawList_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_IntuiObj*,_R_A1 pOS_IObjectMethod*,
                        _R_A2 const pOS_Rectangle*,_R_D0 ULONG mode,_R_D1 ULONG layout,_R_D2 ULONG nT,
                        _R_D3 ULONG oT,_R_A3 const pOS_Rectangle*);
  UBYTE _d10[8];

/** 10 **/
  ULONG (*pOS_PreLayoutMenu_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuList*,_R_A1 const pOS_DrawInfo*);
  UBYTE _d9[8];
  BOOL  (*pOS_LayoutMenu_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_ExList*,_R_A1 const pOS_DrawInfo*,_R_D0 SLONG,_R_D1 SLONG);
  UBYTE _d8[8];
  pOS_MenuList* (*pOS_CreateMenuTagA_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_DrawInfo*,_R_A1 const pOS_MenuTag*,_R_A2 ULONG*);
  UBYTE _d7[8];
  VOID  (*pOS_DeleteMenu_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuList*);
  UBYTE _d6[8];
  ULONG (*pOS_SetMenuHighLight_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuDraw*,_R_A1 pOS_MenuItem*);
  UBYTE _d5[8];
  ULONG (*pOS_MenuHandleIEvent_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuDraw*,_R_A1 const pOS_InputEvent*);
  UBYTE _d4[8];
  BOOL  (*pOS_OpenHandleMenuIEvent_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuDraw*);
  UBYTE _d3[8];
  VOID  (*pOS_CloseHandleMenuIEvent_func)(_R_LB pOS_IntuiDevice*,_R_A0 pOS_MenuDraw*);
  UBYTE _d2[8];
  pOS_MenuItem* (*pOS_GetMenuItemFromNum_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_ExList*,_R_A1 const pOS_MenuNum*);
  UBYTE _d1[8];
  VOID  (*pOS_GetMenuNumFromItem_func)(_R_LB pOS_IntuiDevice*,_R_A0 const pOS_MenuItem*,_R_A1 pOS_MenuNum*);
  UBYTE _d0[8];

  pOS_StdDeviceFunction StdLib;
}; /* => Base */


#endif
